#!/usr/bin/env python

# It Creates a 500 px seamless texture
# author: Pocholo
# date: 5/8/2020

# Comments directed to http://gimpchat.com

# Installation:
# This script should be placed in the user script folder



# Copyright (C)

#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by   
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY# without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <https://www.gnu.org/licenses/>. 


from gimpfu import *

def pm_jean_seamless_texture(size, fgColor):
	
	pdb.gimp_context_push()
	
	#Create the first blue layer
	img = pdb.gimp_image_new(size, size, RGB)
	layer = pdb.gimp_layer_new(img, size, size, RGB, "Jean", 100, NORMAL_MODE)
	pdb.gimp_image_add_layer(img, layer, 0)
	pdb.gimp_context_set_foreground (fgColor)
	pdb.gimp_drawable_fill(layer, FOREGROUND_FILL)
	
	#Create a new layer fill with Noise and change the layer mode
	layer = pdb.gimp_layer_new(img, size, size, RGB, "Blue1", 100, GRAIN_MERGE_MODE)
	pdb.gimp_image_add_layer(img, layer, 0)
	pdb.gimp_drawable_fill(layer, FOREGROUND_FILL)
	pdb.plug_in_hsv_noise(img, layer, 1, 180, 0, 255)
	pdb.gimp_layer_set_mode(layer, GRAIN_MERGE_MODE)
	
	#Create a layer and change layer mode
	layer = pdb.gimp_layer_new(img, size, size, RGB, "Blue2", 100, NORMAL_MODE)
	pdb.gimp_image_add_layer(img, layer, 0)
	pdb.gimp_context_set_foreground (fgColor)
	pdb.gimp_drawable_fill(layer, FOREGROUND_FILL)	
	pdb.gimp_layer_set_mode(layer, GRAIN_MERGE_MODE)
	
	#Create a layer and create the texture
	layer = pdb.gimp_layer_new(img, size, size, RGB, "Texture", 100, NORMAL_MODE)
	pdb.gimp_image_add_layer(img, layer, 0)
	pdb.gimp_context_set_foreground (fgColor)
	pdb.gimp_drawable_fill(layer, FOREGROUND_FILL)	
	pdb.gimp_layer_set_mode(layer, MULTIPLY_MODE)
	pdb.plug_in_newsprint(img, layer, 
										6, 
										0, 
										0, 
										55, 
										1, 
										55, 
										1, 
										55, 
										1, 
										55, 
										1, 
										50)
	#Merge all layers
	layer = pdb.gimp_image_merge_visible_layers(img, CLIP_TO_BOTTOM_LAYER)
										
	gimp.Display(img)
	
	pdb.gimp_context_pop()
	

register(
	"pm_jean_seamless_texture",
	"Creates a denim texture",
	"Creates a denim seamless texture",
	"Pocholo",
	"Pocholo",
	"2020",
	"Jean texture",
	"",
[
	(PF_SPINNER, "size", "Texture size", 500, (100, 1000, 1)),
	(PF_COLOR, "fgcolor", "Texture color", (51, 112, 172)),
],

 [],
pm_jean_seamless_texture, menu="<Image>/Python-Fu/Jean texture")

main()	